package modelo;

import java.util.ArrayList; 
import java.util.Date;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.6152FD4C-6D23-B415-B6AA-5E3083D32571]
// </editor-fold> 
public class DocumentoReq {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B5397BD3-C4F1-EAF8-6B24-D8DD6FA987FC]
    // </editor-fold> 
    private ArrayList<CasodeUso> mCasodeUso=new ArrayList();
    private ArrayList<Elemento_rastreable> mElemento_rastreable=new ArrayList();
    private ArrayList<Requisito> mRequisito=new ArrayList();
    private ArrayList<Requisito_funcional> mRequisito_funcional=new ArrayList();
    private ArrayList<Requisito_informacion> mRequisito_informacion=new ArrayList();
    private ArrayList<Requisito_no_funcional> mRequisito_no_funcional=new ArrayList();
    private ArrayList<Requisito_restriccion> mRequisito_restriccion=new ArrayList();
   
   
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.1D51ABF1-2DD9-82E3-126D-173DEB5FADBA]
    // </editor-fold> 
    public DocumentoReq () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A9A64C79-62B1-D6C4-FB8A-BCD4EF81E5C4]
    // </editor-fold> 
    public ArrayList<CasodeUso> getCasodeUso () {
        return mCasodeUso;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.53D39B7F-03CC-D44E-1C6A-CB6F6C02538E]
    // </editor-fold> 
    public void setCasodeUso (ArrayList<CasodeUso> val) {
        this.mCasodeUso = val;
    }

     public ArrayList<Elemento_rastreable> getElemento_rastreable () {
        return mElemento_rastreable;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.53D39B7F-03CC-D44E-1C6A-CB6F6C02538E]
    // </editor-fold>
    public void setElemento_rastreable (ArrayList<Elemento_rastreable> val) {
        this.mElemento_rastreable = val;
    }

    public ArrayList<Requisito> getRequisito () {
        return mRequisito;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.53D39B7F-03CC-D44E-1C6A-CB6F6C02538E]
    // </editor-fold>
    public void setRequisito (ArrayList<Requisito> val) {
        this.mRequisito = val;
    }

    public ArrayList<Requisito_funcional> getRequisito_funcional () {
        return mRequisito_funcional;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.53D39B7F-03CC-D44E-1C6A-CB6F6C02538E]
    // </editor-fold>
    public void setRequisito_funcional (ArrayList<Requisito_funcional> val) {
        this.mRequisito_funcional = val;
    }

    public ArrayList<Requisito_informacion> getRequisito_informacion () {
        return mRequisito_informacion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.53D39B7F-03CC-D44E-1C6A-CB6F6C02538E]
    // </editor-fold>
    public void setRequisito_informacion (ArrayList<Requisito_informacion> val) {
        this.mRequisito_informacion = val;
    }

    public ArrayList<Requisito_no_funcional> getRequisito_no_funcional () {
        return mRequisito_no_funcional;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.53D39B7F-03CC-D44E-1C6A-CB6F6C02538E]
    // </editor-fold>
    public void setRequisito_no_funcional (ArrayList<Requisito_no_funcional> val) {
        this.mRequisito_no_funcional = val;
    }

    public ArrayList<Requisito_restriccion> getRequisito_restriccion () {
        return mRequisito_restriccion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.53D39B7F-03CC-D44E-1C6A-CB6F6C02538E]
    // </editor-fold>
    public void setRequisito_restriccion (ArrayList<Requisito_restriccion> val) {
        this.mRequisito_restriccion = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3DF3139E-17FC-1508-86A3-908C60405553]
    // </editor-fold> 
    public CasodeUso nuevoCU (String nombreCU, boolean esAbstracto,String eventoActivacion, int frecuencia, String unidadFrecuencia, String precondicion, String postcondicion, String importancia, String urgencia, String estadoDesarrollo, String estabilidad) {

        //// Creo la instancia
        CasodeUso auxCU=new CasodeUso();
        //// Asigno los valores a los atributos
        auxCU.setNombre(nombreCU);
        auxCU.setEsAbstracto(esAbstracto);
        auxCU.setEventoActivacion(eventoActivacion);
        auxCU.setFrecuencia(frecuencia);
        auxCU.setUnidadFrecuencia(unidadFrecuencia);
        auxCU.setPrecondicion(precondicion);
        auxCU.setPostcondicion(postcondicion);
        auxCU.setImportancia(importancia);
        auxCU.setUrgencia(urgencia);
        auxCU.setEstadodeDesarrollo(estadoDesarrollo);
        auxCU.setEstabilidad(estabilidad);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getCasodeUso().add(auxCU);
        return auxCU;
    }

    public Elemento_rastreable nuevoER (int identificador, String nombre, int version, Date fecha, String fuentes, String organizacion, String historia, String comentarios, String autores){

        Elemento_rastreable auxER=new Elemento_rastreable();

        auxER.setIdentificador(identificador);
        auxER.setAutores(autores);
        auxER.setComentarios(comentarios);
        auxER.setFecha(fecha);
        auxER.setFuentes(fuentes);
        auxER.setHistoria(historia);
        auxER.setNombre(nombre);
        auxER.setOrganizacion(organizacion);
        auxER.setVersion(version);

        this.getElemento_rastreable().add(auxER);
        return auxER;
    }

   public Requisito nuevoR (String definirPrioridad){

       Requisito auxR=new Requisito();

       this.getRequisito().add(auxR);
       return auxR;
   }

   public Requisito_funcional nuevoRF (String Nombre, String Texto, String Importancia, String Estabilidad, String EstadoDesarrollo, String Urgencia){

       Requisito_funcional auxRF=new Requisito_funcional();

       auxRF.setNombre(Nombre);
       auxRF.setTexto(Texto);
       auxRF.setImportancia(Importancia);
       auxRF.setEstabilidad(Estabilidad);
       auxRF.setEstado_desarrollo(EstadoDesarrollo);
       auxRF.setUrgencia(Urgencia);

       this.getRequisito_funcional().add(auxRF);
       return auxRF;
   }

   public Requisito_informacion nuevoRI (String Nombre, String ConceptoRelevante, int ValorMaximo, int UnidadMaxima, int ValorMedio, int UnidadMedia, int Nummaximo, int NumMedio, String Importancia, String Estabilidad, String EstadoDesarrollo, String Urgencia){
   
       Requisito_informacion auxRI=new Requisito_informacion();

       auxRI.setNombre(Nombre);
       auxRI.setImportancia(Importancia);
       auxRI.setEstabilidad(Estabilidad);
       auxRI.setEstado_desarrollo(EstadoDesarrollo);
       auxRI.setUrgencia(Urgencia);
       auxRI.setConceptoRelevante(ConceptoRelevante);
       auxRI.setValorMaximo(ValorMaximo);
       auxRI.setUnidadMaxima(UnidadMaxima);
       auxRI.setValorMedio(ValorMedio);
       auxRI.setUnidadMedia(UnidadMedia);
       auxRI.setNummaximo(Nummaximo);
       auxRI.setNumMedio(NumMedio);
       
       this.getRequisito_informacion().add(auxRI);
       return auxRI;
   }

   public Requisito_no_funcional nuevoRNF (String Nombre, String Texto, String Importancia, String Estabilidad, String EstadoDesarrollo, String Urgencia){

       Requisito_no_funcional auxRNF=new Requisito_no_funcional();

     //  this.getRequisito_no_funcional().add(auxRNF);

       auxRNF.setNombre(Nombre);
       auxRNF.setTexto(Texto);
       auxRNF.setImportancia(Importancia);
       auxRNF.setEstabilidad(Estabilidad);
       auxRNF.setEstado_desarrollo(EstadoDesarrollo);
       auxRNF.setUrgencia(Urgencia);

        this.getRequisito_no_funcional().add(auxRNF);
       return auxRNF;
   }

   public Requisito_restriccion nuevoRR (String Nombre, String Texto, String Importancia, String Estabilidad, String EstadoDesarrollo, String Urgencia){

       Requisito_restriccion auxRR=new Requisito_restriccion();

       auxRR.setNombre(Nombre);
       auxRR.setTexto(Texto);
       auxRR.setImportancia(Importancia);
       auxRR.setEstabilidad(Estabilidad);
       auxRR.setEstado_desarrollo(EstadoDesarrollo);
       auxRR.setUrgencia(Urgencia);

       this.getRequisito_restriccion().add(auxRR);
       return auxRR;
   }

}

